------------------------------------------------------------------------------
--                                                                          --
--                    Copyright (C) 2015, AdaCore                           --
--                                                                          --
--  Redistribution and use in source and binary forms, with or without      --
--  modification, are permitted provided that the following conditions are  --
--  met:                                                                    --
--     1. Redistributions of source code must retain the above copyright    --
--        notice, this list of conditions and the following disclaimer.     --
--     2. Redistributions in binary form must reproduce the above copyright --
--        notice, this list of conditions and the following disclaimer in   --
--        the documentation and/or other materials provided with the        --
--        distribution.                                                     --
--     3. Neither the name of STMicroelectronics nor the names of its       --
--        contributors may be used to endorse or promote products derived   --
--        from this software without specific prior written permission.     --
--                                                                          --
--   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS    --
--   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT      --
--   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR  --
--   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT   --
--   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, --
--   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT       --
--   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,  --
--   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY  --
--   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT    --
--   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE  --
--   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.   --
--                                                                          --
--                                                                          --
--  This file is based on:                                                  --
--                                                                          --
--   @file    font*.c                                                       --
--   @author  MCD Application Team                                          --
--   @version V1.1.0                                                        --
--   @date    19-June-2014                                                  --
--   @brief   This file provides fonts for the LCD driver.                  --
--                                                                          --
--   COPYRIGHT(c) 2014 STMicroelectronics                                   --
------------------------------------------------------------------------------

package body BMP_Fonts is

   BMP_Font16x24 : constant array (0 .. 2279) of UInt16 :=
     (16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#00CC#,
      16#00CC#,
      16#00CC#,
      16#00CC#,
      16#00CC#,
      16#00CC#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0C60#,
      16#0C60#,
      16#0C60#,
      16#0630#,
      16#0630#,
      16#1FFE#,
      16#1FFE#,
      16#0630#,
      16#0738#,
      16#0318#,
      16#1FFE#,
      16#1FFE#,
      16#0318#,
      16#0318#,
      16#018C#,
      16#018C#,
      16#018C#,
      16#0000#,
      16#0000#,
      16#0080#,
      16#03E0#,
      16#0FF8#,
      16#0E9C#,
      16#1C8C#,
      16#188C#,
      16#008C#,
      16#0098#,
      16#01F8#,
      16#07E0#,
      16#0E80#,
      16#1C80#,
      16#188C#,
      16#188C#,
      16#189C#,
      16#0CB8#,
      16#0FF0#,
      16#03E0#,
      16#0080#,
      16#0080#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#180E#,
      16#0C1B#,
      16#0C11#,
      16#0611#,
      16#0611#,
      16#0311#,
      16#0311#,
      16#019B#,
      16#018E#,
      16#38C0#,
      16#6CC0#,
      16#4460#,
      16#4460#,
      16#4430#,
      16#4430#,
      16#4418#,
      16#6C18#,
      16#380C#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#01E0#,
      16#03F0#,
      16#0738#,
      16#0618#,
      16#0618#,
      16#0330#,
      16#01F0#,
      16#00F0#,
      16#00F8#,
      16#319C#,
      16#330E#,
      16#1E06#,
      16#1C06#,
      16#1C06#,
      16#3F06#,
      16#73FC#,
      16#21F0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0200#,
      16#0300#,
      16#0180#,
      16#00C0#,
      16#00C0#,
      16#0060#,
      16#0060#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0060#,
      16#0060#,
      16#00C0#,
      16#00C0#,
      16#0180#,
      16#0300#,
      16#0200#,
      16#0000#,
      16#0000#,
      16#0020#,
      16#0060#,
      16#00C0#,
      16#0180#,
      16#0180#,
      16#0300#,
      16#0300#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0300#,
      16#0300#,
      16#0180#,
      16#0180#,
      16#00C0#,
      16#0060#,
      16#0020#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#00C0#,
      16#00C0#,
      16#06D8#,
      16#07F8#,
      16#01E0#,
      16#0330#,
      16#0738#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#3FFC#,
      16#3FFC#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0100#,
      16#0100#,
      16#0080#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#07E0#,
      16#07E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#00C0#,
      16#00C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0C00#,
      16#0C00#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0380#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#0060#,
      16#0060#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03E0#,
      16#07F0#,
      16#0E38#,
      16#0C18#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#0C18#,
      16#0E38#,
      16#07F0#,
      16#03E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0100#,
      16#0180#,
      16#01C0#,
      16#01F0#,
      16#0198#,
      16#0188#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03E0#,
      16#0FF8#,
      16#0C18#,
      16#180C#,
      16#180C#,
      16#1800#,
      16#1800#,
      16#0C00#,
      16#0600#,
      16#0300#,
      16#0180#,
      16#00C0#,
      16#0060#,
      16#0030#,
      16#0018#,
      16#1FFC#,
      16#1FFC#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#01E0#,
      16#07F8#,
      16#0E18#,
      16#0C0C#,
      16#0C0C#,
      16#0C00#,
      16#0600#,
      16#03C0#,
      16#07C0#,
      16#0C00#,
      16#1800#,
      16#1800#,
      16#180C#,
      16#180C#,
      16#0C18#,
      16#07F8#,
      16#03E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0C00#,
      16#0E00#,
      16#0F00#,
      16#0F00#,
      16#0D80#,
      16#0CC0#,
      16#0C60#,
      16#0C60#,
      16#0C30#,
      16#0C18#,
      16#0C0C#,
      16#3FFC#,
      16#3FFC#,
      16#0C00#,
      16#0C00#,
      16#0C00#,
      16#0C00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0FF8#,
      16#0FF8#,
      16#0018#,
      16#0018#,
      16#000C#,
      16#03EC#,
      16#07FC#,
      16#0E1C#,
      16#1C00#,
      16#1800#,
      16#1800#,
      16#1800#,
      16#180C#,
      16#0C1C#,
      16#0E18#,
      16#07F8#,
      16#03E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#07C0#,
      16#0FF0#,
      16#1C38#,
      16#1818#,
      16#0018#,
      16#000C#,
      16#03CC#,
      16#0FEC#,
      16#0E3C#,
      16#1C1C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#1C18#,
      16#0E38#,
      16#07F0#,
      16#03E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1FFC#,
      16#1FFC#,
      16#0C00#,
      16#0600#,
      16#0600#,
      16#0300#,
      16#0380#,
      16#0180#,
      16#01C0#,
      16#00C0#,
      16#00E0#,
      16#0060#,
      16#0060#,
      16#0070#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03E0#,
      16#07F0#,
      16#0E38#,
      16#0C18#,
      16#0C18#,
      16#0C18#,
      16#0638#,
      16#07F0#,
      16#07F0#,
      16#0C18#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#0C38#,
      16#0FF8#,
      16#03E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03E0#,
      16#07F0#,
      16#0E38#,
      16#0C1C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#1C1C#,
      16#1E38#,
      16#1BF8#,
      16#19E0#,
      16#1800#,
      16#0C00#,
      16#0C00#,
      16#0E1C#,
      16#07F8#,
      16#01F0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0100#,
      16#0100#,
      16#0080#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1000#,
      16#1C00#,
      16#0F80#,
      16#03E0#,
      16#00F8#,
      16#0018#,
      16#00F8#,
      16#03E0#,
      16#0F80#,
      16#1C00#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1FF8#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1FF8#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0008#,
      16#0038#,
      16#01F0#,
      16#07C0#,
      16#1F00#,
      16#1800#,
      16#1F00#,
      16#07C0#,
      16#01F0#,
      16#0038#,
      16#0008#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03E0#,
      16#0FF8#,
      16#0C18#,
      16#180C#,
      16#180C#,
      16#1800#,
      16#0C00#,
      16#0600#,
      16#0300#,
      16#0180#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#0000#,
      16#0000#,
      16#00C0#,
      16#00C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#07E0#,
      16#1818#,
      16#2004#,
      16#29C2#,
      16#4A22#,
      16#4411#,
      16#4409#,
      16#4409#,
      16#4409#,
      16#2209#,
      16#1311#,
      16#0CE2#,
      16#4002#,
      16#2004#,
      16#1818#,
      16#07E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0380#,
      16#0380#,
      16#06C0#,
      16#06C0#,
      16#06C0#,
      16#0C60#,
      16#0C60#,
      16#1830#,
      16#1830#,
      16#1830#,
      16#3FF8#,
      16#3FF8#,
      16#701C#,
      16#600C#,
      16#600C#,
      16#C006#,
      16#C006#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03FC#,
      16#0FFC#,
      16#0C0C#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#0C0C#,
      16#07FC#,
      16#0FFC#,
      16#180C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#180C#,
      16#1FFC#,
      16#07FC#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#07C0#,
      16#1FF0#,
      16#3838#,
      16#301C#,
      16#700C#,
      16#6006#,
      16#0006#,
      16#0006#,
      16#0006#,
      16#0006#,
      16#0006#,
      16#0006#,
      16#6006#,
      16#700C#,
      16#301C#,
      16#1FF0#,
      16#07E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03FE#,
      16#0FFE#,
      16#0E06#,
      16#1806#,
      16#1806#,
      16#3006#,
      16#3006#,
      16#3006#,
      16#3006#,
      16#3006#,
      16#3006#,
      16#3006#,
      16#1806#,
      16#1806#,
      16#0E06#,
      16#0FFE#,
      16#03FE#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3FFC#,
      16#3FFC#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#1FFC#,
      16#1FFC#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#3FFC#,
      16#3FFC#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3FF8#,
      16#3FF8#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#1FF8#,
      16#1FF8#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0FE0#,
      16#3FF8#,
      16#783C#,
      16#600E#,
      16#E006#,
      16#C007#,
      16#0003#,
      16#0003#,
      16#FE03#,
      16#FE03#,
      16#C003#,
      16#C007#,
      16#C006#,
      16#C00E#,
      16#F03C#,
      16#3FF8#,
      16#0FE0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#3FFC#,
      16#3FFC#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0600#,
      16#0618#,
      16#0618#,
      16#0738#,
      16#03F0#,
      16#01E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3006#,
      16#1806#,
      16#0C06#,
      16#0606#,
      16#0306#,
      16#0186#,
      16#00C6#,
      16#0066#,
      16#0076#,
      16#00DE#,
      16#018E#,
      16#0306#,
      16#0606#,
      16#0C06#,
      16#1806#,
      16#3006#,
      16#6006#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#1FF8#,
      16#1FF8#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#E00E#,
      16#F01E#,
      16#F01E#,
      16#F01E#,
      16#D836#,
      16#D836#,
      16#D836#,
      16#D836#,
      16#CC66#,
      16#CC66#,
      16#CC66#,
      16#C6C6#,
      16#C6C6#,
      16#C6C6#,
      16#C6C6#,
      16#C386#,
      16#C386#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#300C#,
      16#301C#,
      16#303C#,
      16#303C#,
      16#306C#,
      16#306C#,
      16#30CC#,
      16#30CC#,
      16#318C#,
      16#330C#,
      16#330C#,
      16#360C#,
      16#360C#,
      16#3C0C#,
      16#3C0C#,
      16#380C#,
      16#300C#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#07E0#,
      16#1FF8#,
      16#381C#,
      16#700E#,
      16#6006#,
      16#C003#,
      16#C003#,
      16#C003#,
      16#C003#,
      16#C003#,
      16#C003#,
      16#C003#,
      16#6006#,
      16#700E#,
      16#381C#,
      16#1FF8#,
      16#07E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0FFC#,
      16#1FFC#,
      16#380C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#180C#,
      16#1FFC#,
      16#07FC#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#07E0#,
      16#1FF8#,
      16#381C#,
      16#700E#,
      16#6006#,
      16#E003#,
      16#C003#,
      16#C003#,
      16#C003#,
      16#C003#,
      16#C003#,
      16#E007#,
      16#6306#,
      16#3F0E#,
      16#3C1C#,
      16#3FF8#,
      16#F7E0#,
      16#C000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0FFE#,
      16#1FFE#,
      16#3806#,
      16#3006#,
      16#3006#,
      16#3006#,
      16#3806#,
      16#1FFE#,
      16#07FE#,
      16#0306#,
      16#0606#,
      16#0C06#,
      16#1806#,
      16#1806#,
      16#3006#,
      16#3006#,
      16#6006#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03E0#,
      16#0FF8#,
      16#0C1C#,
      16#180C#,
      16#180C#,
      16#000C#,
      16#001C#,
      16#03F8#,
      16#0FE0#,
      16#1E00#,
      16#3800#,
      16#3006#,
      16#3006#,
      16#300E#,
      16#1C1C#,
      16#0FF8#,
      16#07E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7FFE#,
      16#7FFE#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#300C#,
      16#1818#,
      16#1FF8#,
      16#07E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#6003#,
      16#3006#,
      16#3006#,
      16#3006#,
      16#180C#,
      16#180C#,
      16#180C#,
      16#0C18#,
      16#0C18#,
      16#0E38#,
      16#0630#,
      16#0630#,
      16#0770#,
      16#0360#,
      16#0360#,
      16#01C0#,
      16#01C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#6003#,
      16#61C3#,
      16#61C3#,
      16#61C3#,
      16#3366#,
      16#3366#,
      16#3366#,
      16#3366#,
      16#3366#,
      16#3366#,
      16#1B6C#,
      16#1B6C#,
      16#1B6C#,
      16#1A2C#,
      16#1E3C#,
      16#0E38#,
      16#0E38#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#E00F#,
      16#700C#,
      16#3018#,
      16#1830#,
      16#0C70#,
      16#0E60#,
      16#07C0#,
      16#0380#,
      16#0380#,
      16#03C0#,
      16#06E0#,
      16#0C70#,
      16#1C30#,
      16#1818#,
      16#300C#,
      16#600E#,
      16#E007#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#C003#,
      16#6006#,
      16#300C#,
      16#381C#,
      16#1838#,
      16#0C30#,
      16#0660#,
      16#07E0#,
      16#03C0#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7FFC#,
      16#7FFC#,
      16#6000#,
      16#3000#,
      16#1800#,
      16#0C00#,
      16#0600#,
      16#0300#,
      16#0180#,
      16#00C0#,
      16#0060#,
      16#0030#,
      16#0018#,
      16#000C#,
      16#0006#,
      16#7FFE#,
      16#7FFE#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03E0#,
      16#03E0#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#03E0#,
      16#03E0#,
      16#0000#,
      16#0000#,
      16#0030#,
      16#0030#,
      16#0060#,
      16#0060#,
      16#0060#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#01C0#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0600#,
      16#0600#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03E0#,
      16#03E0#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#0300#,
      16#03E0#,
      16#03E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#01C0#,
      16#01C0#,
      16#0360#,
      16#0360#,
      16#0360#,
      16#0630#,
      16#0630#,
      16#0C18#,
      16#0C18#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#FFFF#,
      16#FFFF#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03F0#,
      16#07F8#,
      16#0C1C#,
      16#0C0C#,
      16#0F00#,
      16#0FF0#,
      16#0CF8#,
      16#0C0C#,
      16#0C0C#,
      16#0F1C#,
      16#0FF8#,
      16#18F0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#03D8#,
      16#0FF8#,
      16#0C38#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#0C38#,
      16#0FF8#,
      16#03D8#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03C0#,
      16#07F0#,
      16#0E30#,
      16#0C18#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0C18#,
      16#0E30#,
      16#07F0#,
      16#03C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1800#,
      16#1800#,
      16#1800#,
      16#1800#,
      16#1800#,
      16#1BC0#,
      16#1FF0#,
      16#1C30#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1C30#,
      16#1FF0#,
      16#1BC0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03C0#,
      16#0FF0#,
      16#0C30#,
      16#1818#,
      16#1FF8#,
      16#1FF8#,
      16#0018#,
      16#0018#,
      16#1838#,
      16#1C30#,
      16#0FF0#,
      16#07C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0F80#,
      16#0FC0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#07F0#,
      16#07F0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0DE0#,
      16#0FF8#,
      16#0E18#,
      16#0C0C#,
      16#0C0C#,
      16#0C0C#,
      16#0C0C#,
      16#0C0C#,
      16#0C0C#,
      16#0E18#,
      16#0FF8#,
      16#0DE0#,
      16#0C00#,
      16#0C0C#,
      16#061C#,
      16#07F8#,
      16#01F0#,
      16#0000#,
      16#0000#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#07D8#,
      16#0FF8#,
      16#1C38#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#00C0#,
      16#00C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#00C0#,
      16#00C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00F8#,
      16#0078#,
      16#0000#,
      16#0000#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#000C#,
      16#0C0C#,
      16#060C#,
      16#030C#,
      16#018C#,
      16#00CC#,
      16#006C#,
      16#00FC#,
      16#019C#,
      16#038C#,
      16#030C#,
      16#060C#,
      16#0C0C#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3C7C#,
      16#7EFF#,
      16#E3C7#,
      16#C183#,
      16#C183#,
      16#C183#,
      16#C183#,
      16#C183#,
      16#C183#,
      16#C183#,
      16#C183#,
      16#C183#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0798#,
      16#0FF8#,
      16#1C38#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03C0#,
      16#0FF0#,
      16#0C30#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#0C30#,
      16#0FF0#,
      16#03C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03D8#,
      16#0FF8#,
      16#0C38#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#0C38#,
      16#0FF8#,
      16#03D8#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0018#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1BC0#,
      16#1FF0#,
      16#1C30#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1C30#,
      16#1FF0#,
      16#1BC0#,
      16#1800#,
      16#1800#,
      16#1800#,
      16#1800#,
      16#1800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#07B0#,
      16#03F0#,
      16#0070#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0030#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#03E0#,
      16#03F0#,
      16#0E38#,
      16#0C18#,
      16#0038#,
      16#03F0#,
      16#07C0#,
      16#0C00#,
      16#0C18#,
      16#0E38#,
      16#07F0#,
      16#03E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0080#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#07F0#,
      16#07F0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#07C0#,
      16#0780#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1818#,
      16#1C38#,
      16#1FF0#,
      16#19E0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#180C#,
      16#0C18#,
      16#0C18#,
      16#0C18#,
      16#0630#,
      16#0630#,
      16#0630#,
      16#0360#,
      16#0360#,
      16#0360#,
      16#01C0#,
      16#01C0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#41C1#,
      16#41C1#,
      16#61C3#,
      16#6363#,
      16#6363#,
      16#6363#,
      16#3636#,
      16#3636#,
      16#3636#,
      16#1C1C#,
      16#1C1C#,
      16#1C1C#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#381C#,
      16#1C38#,
      16#0C30#,
      16#0660#,
      16#0360#,
      16#0360#,
      16#0360#,
      16#0360#,
      16#0660#,
      16#0C30#,
      16#1C38#,
      16#381C#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3018#,
      16#1830#,
      16#1830#,
      16#1870#,
      16#0C60#,
      16#0C60#,
      16#0CE0#,
      16#06C0#,
      16#06C0#,
      16#0380#,
      16#0380#,
      16#0380#,
      16#0180#,
      16#0180#,
      16#01C0#,
      16#00F0#,
      16#0070#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1FFC#,
      16#1FFC#,
      16#0C00#,
      16#0600#,
      16#0300#,
      16#0180#,
      16#00C0#,
      16#0060#,
      16#0030#,
      16#0018#,
      16#1FFC#,
      16#1FFC#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0300#,
      16#0180#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#0060#,
      16#0060#,
      16#0030#,
      16#0060#,
      16#0040#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#00C0#,
      16#0180#,
      16#0300#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0000#,
      16#0000#,
      16#0060#,
      16#00C0#,
      16#01C0#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0300#,
      16#0300#,
      16#0600#,
      16#0300#,
      16#0100#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#0180#,
      16#00C0#,
      16#0060#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#10F0#,
      16#1FF8#,
      16#0F08#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#);

   BMP_Font12x12 : constant array (0 .. 1151) of UInt16 :=
     (16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#5000#,
      16#5000#,
      16#5000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0900#,
      16#0900#,
      16#1200#,
      16#7f00#,
      16#1200#,
      16#7f00#,
      16#1200#,
      16#2400#,
      16#2400#,
      16#0000#,
      16#0000#,
      16#1000#,
      16#3800#,
      16#5400#,
      16#5000#,
      16#5000#,
      16#3800#,
      16#1400#,
      16#5400#,
      16#5400#,
      16#3800#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#3080#,
      16#4900#,
      16#4900#,
      16#4a00#,
      16#32c0#,
      16#0520#,
      16#0920#,
      16#0920#,
      16#10c0#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0c00#,
      16#1200#,
      16#1200#,
      16#1400#,
      16#1800#,
      16#2500#,
      16#2300#,
      16#2300#,
      16#1d80#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0800#,
      16#1000#,
      16#1000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#1000#,
      16#1000#,
      16#0000#,
      16#4000#,
      16#2000#,
      16#2000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#2000#,
      16#7000#,
      16#2000#,
      16#5000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0800#,
      16#0800#,
      16#7f00#,
      16#0800#,
      16#0800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2000#,
      16#2000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#4000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1000#,
      16#2800#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#2800#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1000#,
      16#3000#,
      16#5000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3000#,
      16#4800#,
      16#4400#,
      16#0400#,
      16#0800#,
      16#1000#,
      16#2000#,
      16#4000#,
      16#7c00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3000#,
      16#4800#,
      16#0400#,
      16#0800#,
      16#1000#,
      16#0800#,
      16#4400#,
      16#4800#,
      16#3000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0800#,
      16#1800#,
      16#1800#,
      16#2800#,
      16#2800#,
      16#4800#,
      16#7c00#,
      16#0800#,
      16#0800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3c00#,
      16#2000#,
      16#4000#,
      16#7000#,
      16#4800#,
      16#0400#,
      16#4400#,
      16#4800#,
      16#3000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1800#,
      16#2400#,
      16#4000#,
      16#5000#,
      16#6800#,
      16#4400#,
      16#4400#,
      16#2800#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7c00#,
      16#0400#,
      16#0800#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1000#,
      16#2800#,
      16#4400#,
      16#2800#,
      16#1000#,
      16#2800#,
      16#4400#,
      16#2800#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1000#,
      16#2800#,
      16#4400#,
      16#4400#,
      16#2c00#,
      16#1400#,
      16#0400#,
      16#4800#,
      16#3000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2000#,
      16#2000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0400#,
      16#0800#,
      16#3000#,
      16#4000#,
      16#3000#,
      16#0800#,
      16#0400#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7c00#,
      16#0000#,
      16#0000#,
      16#7c00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4000#,
      16#2000#,
      16#1800#,
      16#0400#,
      16#1800#,
      16#2000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3800#,
      16#6400#,
      16#4400#,
      16#0400#,
      16#0800#,
      16#1000#,
      16#1000#,
      16#0000#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0f80#,
      16#1040#,
      16#2ea0#,
      16#51a0#,
      16#5120#,
      16#5120#,
      16#5120#,
      16#5320#,
      16#4dc0#,
      16#2020#,
      16#1040#,
      16#0000#,
      16#0800#,
      16#1400#,
      16#1400#,
      16#1400#,
      16#2200#,
      16#3e00#,
      16#2200#,
      16#4100#,
      16#4100#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3c00#,
      16#2200#,
      16#2200#,
      16#2200#,
      16#3c00#,
      16#2200#,
      16#2200#,
      16#2200#,
      16#3c00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0e00#,
      16#1100#,
      16#2100#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2100#,
      16#1100#,
      16#0e00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3c00#,
      16#2200#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2200#,
      16#3c00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3e00#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#3e00#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#3e00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3e00#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#3c00#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0e00#,
      16#1100#,
      16#2100#,
      16#2000#,
      16#2700#,
      16#2100#,
      16#2100#,
      16#1100#,
      16#0e00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#3f00#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#4800#,
      16#4800#,
      16#3000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2200#,
      16#2400#,
      16#2800#,
      16#2800#,
      16#3800#,
      16#2800#,
      16#2400#,
      16#2400#,
      16#2200#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#3e00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2080#,
      16#3180#,
      16#3180#,
      16#3180#,
      16#2a80#,
      16#2a80#,
      16#2a80#,
      16#2a80#,
      16#2480#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2100#,
      16#3100#,
      16#3100#,
      16#2900#,
      16#2900#,
      16#2500#,
      16#2300#,
      16#2300#,
      16#2100#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0c00#,
      16#1200#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#1200#,
      16#0c00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3c00#,
      16#2200#,
      16#2200#,
      16#2200#,
      16#3c00#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0c00#,
      16#1200#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#1600#,
      16#0d00#,
      16#0100#,
      16#0000#,
      16#0000#,
      16#3e00#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#3e00#,
      16#2400#,
      16#2200#,
      16#2100#,
      16#2080#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1c00#,
      16#2200#,
      16#2200#,
      16#2000#,
      16#1c00#,
      16#0200#,
      16#2200#,
      16#2200#,
      16#1c00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3e00#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#2100#,
      16#1200#,
      16#0c00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4100#,
      16#4100#,
      16#2200#,
      16#2200#,
      16#2200#,
      16#1400#,
      16#1400#,
      16#1400#,
      16#0800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4440#,
      16#4a40#,
      16#2a40#,
      16#2a80#,
      16#2a80#,
      16#2a80#,
      16#2a80#,
      16#2a80#,
      16#1100#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4100#,
      16#2200#,
      16#1400#,
      16#1400#,
      16#0800#,
      16#1400#,
      16#1400#,
      16#2200#,
      16#4100#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4100#,
      16#2200#,
      16#2200#,
      16#1400#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7e00#,
      16#0200#,
      16#0400#,
      16#0800#,
      16#1000#,
      16#1000#,
      16#2000#,
      16#4000#,
      16#7e00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#4000#,
      16#4000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#1000#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#6000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#1000#,
      16#2800#,
      16#2800#,
      16#2800#,
      16#4400#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7e00#,
      16#4000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3800#,
      16#4400#,
      16#0400#,
      16#3c00#,
      16#4400#,
      16#4400#,
      16#3c00#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4000#,
      16#4000#,
      16#5800#,
      16#6400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#6400#,
      16#5800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3000#,
      16#4800#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4800#,
      16#3000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0400#,
      16#0400#,
      16#3400#,
      16#4c00#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4c00#,
      16#3400#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3800#,
      16#4400#,
      16#4400#,
      16#7c00#,
      16#4000#,
      16#4400#,
      16#3800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#6000#,
      16#4000#,
      16#e000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3400#,
      16#4c00#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4c00#,
      16#3400#,
      16#0400#,
      16#4400#,
      16#0000#,
      16#4000#,
      16#4000#,
      16#5800#,
      16#6400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4000#,
      16#0000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4000#,
      16#0000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#0000#,
      16#4000#,
      16#4000#,
      16#4800#,
      16#5000#,
      16#6000#,
      16#5000#,
      16#5000#,
      16#4800#,
      16#4800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#5200#,
      16#6d00#,
      16#4900#,
      16#4900#,
      16#4900#,
      16#4900#,
      16#4900#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#5800#,
      16#6400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3800#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#3800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#5800#,
      16#6400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#6400#,
      16#5800#,
      16#4000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3400#,
      16#4c00#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4c00#,
      16#3400#,
      16#0400#,
      16#0400#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#5000#,
      16#6000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#3000#,
      16#4800#,
      16#4000#,
      16#3000#,
      16#0800#,
      16#4800#,
      16#3000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4000#,
      16#4000#,
      16#e000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#4000#,
      16#6000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4400#,
      16#4c00#,
      16#3400#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4400#,
      16#4400#,
      16#2800#,
      16#2800#,
      16#2800#,
      16#2800#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4900#,
      16#4900#,
      16#5500#,
      16#5500#,
      16#5500#,
      16#5500#,
      16#2200#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4400#,
      16#2800#,
      16#2800#,
      16#1000#,
      16#2800#,
      16#2800#,
      16#4400#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#4400#,
      16#4400#,
      16#2800#,
      16#2800#,
      16#2800#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#1000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7800#,
      16#0800#,
      16#1000#,
      16#2000#,
      16#2000#,
      16#4000#,
      16#7800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#1000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#4000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#4000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#1000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#2000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7400#,
      16#5800#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#0000#,
      16#7000#,
      16#5000#,
      16#5000#,
      16#5000#,
      16#5000#,
      16#5000#,
      16#5000#,
      16#7000#,
      16#0000#,
      16#0000#);

   BMP_Font8x8 : constant array (0 .. 767) of UInt8 :=
     (16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#40#,
      16#40#,
      16#40#,
      16#40#,
      16#40#,
      16#40#,
      16#00#,
      16#40#,
      16#a0#,
      16#a0#,
      16#a0#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#24#,
      16#24#,
      16#fe#,
      16#48#,
      16#fc#,
      16#48#,
      16#48#,
      16#38#,
      16#54#,
      16#50#,
      16#38#,
      16#14#,
      16#14#,
      16#54#,
      16#38#,
      16#44#,
      16#a8#,
      16#a8#,
      16#50#,
      16#14#,
      16#1a#,
      16#2a#,
      16#24#,
      16#10#,
      16#28#,
      16#28#,
      16#10#,
      16#74#,
      16#4c#,
      16#4c#,
      16#30#,
      16#10#,
      16#10#,
      16#10#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#08#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#08#,
      16#10#,
      16#08#,
      16#08#,
      16#08#,
      16#08#,
      16#08#,
      16#08#,
      16#10#,
      16#00#,
      16#00#,
      16#24#,
      16#18#,
      16#3c#,
      16#18#,
      16#24#,
      16#00#,
      16#00#,
      16#00#,
      16#10#,
      16#10#,
      16#7c#,
      16#10#,
      16#10#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#08#,
      16#08#,
      16#10#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#3c#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#18#,
      16#18#,
      16#08#,
      16#08#,
      16#08#,
      16#10#,
      16#10#,
      16#20#,
      16#20#,
      16#20#,
      16#18#,
      16#24#,
      16#24#,
      16#24#,
      16#24#,
      16#24#,
      16#24#,
      16#18#,
      16#08#,
      16#18#,
      16#28#,
      16#08#,
      16#08#,
      16#08#,
      16#08#,
      16#08#,
      16#38#,
      16#44#,
      16#00#,
      16#04#,
      16#08#,
      16#10#,
      16#20#,
      16#7c#,
      16#18#,
      16#24#,
      16#04#,
      16#18#,
      16#04#,
      16#04#,
      16#24#,
      16#18#,
      16#04#,
      16#0c#,
      16#14#,
      16#24#,
      16#44#,
      16#7e#,
      16#04#,
      16#04#,
      16#3c#,
      16#20#,
      16#20#,
      16#38#,
      16#04#,
      16#04#,
      16#24#,
      16#18#,
      16#18#,
      16#24#,
      16#20#,
      16#38#,
      16#24#,
      16#24#,
      16#24#,
      16#18#,
      16#3c#,
      16#04#,
      16#08#,
      16#08#,
      16#08#,
      16#10#,
      16#10#,
      16#10#,
      16#18#,
      16#24#,
      16#24#,
      16#18#,
      16#24#,
      16#24#,
      16#24#,
      16#18#,
      16#18#,
      16#24#,
      16#24#,
      16#24#,
      16#1c#,
      16#04#,
      16#24#,
      16#18#,
      16#00#,
      16#00#,
      16#10#,
      16#00#,
      16#00#,
      16#10#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#08#,
      16#00#,
      16#00#,
      16#08#,
      16#10#,
      16#00#,
      16#00#,
      16#00#,
      16#04#,
      16#18#,
      16#20#,
      16#18#,
      16#04#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#3c#,
      16#00#,
      16#3c#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#20#,
      16#18#,
      16#04#,
      16#18#,
      16#20#,
      16#00#,
      16#18#,
      16#24#,
      16#04#,
      16#08#,
      16#10#,
      16#10#,
      16#00#,
      16#10#,
      16#3c#,
      16#42#,
      16#99#,
      16#a5#,
      16#a5#,
      16#9d#,
      16#42#,
      16#38#,
      16#38#,
      16#44#,
      16#44#,
      16#44#,
      16#7c#,
      16#44#,
      16#44#,
      16#44#,
      16#78#,
      16#44#,
      16#44#,
      16#78#,
      16#44#,
      16#44#,
      16#44#,
      16#78#,
      16#1c#,
      16#22#,
      16#42#,
      16#40#,
      16#40#,
      16#42#,
      16#22#,
      16#1c#,
      16#70#,
      16#48#,
      16#44#,
      16#44#,
      16#44#,
      16#44#,
      16#48#,
      16#70#,
      16#7c#,
      16#40#,
      16#40#,
      16#7c#,
      16#40#,
      16#40#,
      16#40#,
      16#7c#,
      16#3c#,
      16#20#,
      16#20#,
      16#38#,
      16#20#,
      16#20#,
      16#20#,
      16#20#,
      16#1c#,
      16#22#,
      16#42#,
      16#40#,
      16#4e#,
      16#42#,
      16#22#,
      16#1c#,
      16#44#,
      16#44#,
      16#44#,
      16#7c#,
      16#44#,
      16#44#,
      16#44#,
      16#44#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#04#,
      16#04#,
      16#04#,
      16#04#,
      16#04#,
      16#24#,
      16#24#,
      16#18#,
      16#44#,
      16#48#,
      16#50#,
      16#70#,
      16#50#,
      16#48#,
      16#48#,
      16#44#,
      16#20#,
      16#20#,
      16#20#,
      16#20#,
      16#20#,
      16#20#,
      16#20#,
      16#3c#,
      16#82#,
      16#c6#,
      16#c6#,
      16#aa#,
      16#aa#,
      16#aa#,
      16#aa#,
      16#92#,
      16#42#,
      16#62#,
      16#52#,
      16#52#,
      16#4a#,
      16#4a#,
      16#46#,
      16#42#,
      16#18#,
      16#24#,
      16#42#,
      16#42#,
      16#42#,
      16#42#,
      16#24#,
      16#18#,
      16#78#,
      16#44#,
      16#44#,
      16#44#,
      16#78#,
      16#40#,
      16#40#,
      16#40#,
      16#18#,
      16#24#,
      16#42#,
      16#42#,
      16#42#,
      16#42#,
      16#2c#,
      16#1a#,
      16#78#,
      16#44#,
      16#44#,
      16#78#,
      16#50#,
      16#48#,
      16#44#,
      16#42#,
      16#38#,
      16#44#,
      16#40#,
      16#38#,
      16#04#,
      16#44#,
      16#44#,
      16#38#,
      16#7c#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#42#,
      16#42#,
      16#42#,
      16#42#,
      16#42#,
      16#42#,
      16#24#,
      16#18#,
      16#44#,
      16#44#,
      16#28#,
      16#28#,
      16#28#,
      16#28#,
      16#28#,
      16#10#,
      16#92#,
      16#aa#,
      16#aa#,
      16#aa#,
      16#aa#,
      16#aa#,
      16#aa#,
      16#44#,
      16#42#,
      16#24#,
      16#24#,
      16#18#,
      16#18#,
      16#24#,
      16#24#,
      16#42#,
      16#44#,
      16#28#,
      16#28#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#7c#,
      16#04#,
      16#08#,
      16#10#,
      16#10#,
      16#20#,
      16#40#,
      16#7c#,
      16#1c#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#1c#,
      16#10#,
      16#10#,
      16#08#,
      16#08#,
      16#08#,
      16#08#,
      16#04#,
      16#04#,
      16#1c#,
      16#04#,
      16#04#,
      16#04#,
      16#04#,
      16#04#,
      16#04#,
      16#1c#,
      16#10#,
      16#28#,
      16#44#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#20#,
      16#10#,
      16#10#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#00#,
      16#18#,
      16#04#,
      16#1c#,
      16#24#,
      16#24#,
      16#1c#,
      16#20#,
      16#20#,
      16#28#,
      16#34#,
      16#24#,
      16#24#,
      16#34#,
      16#28#,
      16#00#,
      16#00#,
      16#18#,
      16#24#,
      16#20#,
      16#20#,
      16#24#,
      16#18#,
      16#04#,
      16#04#,
      16#14#,
      16#2c#,
      16#24#,
      16#24#,
      16#2c#,
      16#14#,
      16#00#,
      16#00#,
      16#18#,
      16#24#,
      16#3c#,
      16#20#,
      16#24#,
      16#18#,
      16#00#,
      16#18#,
      16#10#,
      16#10#,
      16#18#,
      16#10#,
      16#10#,
      16#10#,
      16#00#,
      16#18#,
      16#24#,
      16#24#,
      16#18#,
      16#04#,
      16#24#,
      16#18#,
      16#20#,
      16#20#,
      16#28#,
      16#34#,
      16#24#,
      16#24#,
      16#24#,
      16#24#,
      16#10#,
      16#00#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#08#,
      16#00#,
      16#08#,
      16#08#,
      16#08#,
      16#08#,
      16#28#,
      16#10#,
      16#20#,
      16#20#,
      16#24#,
      16#28#,
      16#30#,
      16#28#,
      16#24#,
      16#24#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#00#,
      16#00#,
      16#a6#,
      16#da#,
      16#92#,
      16#92#,
      16#92#,
      16#92#,
      16#00#,
      16#00#,
      16#28#,
      16#34#,
      16#24#,
      16#24#,
      16#24#,
      16#24#,
      16#00#,
      16#00#,
      16#18#,
      16#24#,
      16#24#,
      16#24#,
      16#24#,
      16#18#,
      16#00#,
      16#28#,
      16#34#,
      16#24#,
      16#38#,
      16#20#,
      16#20#,
      16#20#,
      16#00#,
      16#14#,
      16#2c#,
      16#24#,
      16#1c#,
      16#04#,
      16#04#,
      16#04#,
      16#00#,
      16#00#,
      16#2c#,
      16#30#,
      16#20#,
      16#20#,
      16#20#,
      16#20#,
      16#00#,
      16#00#,
      16#18#,
      16#24#,
      16#10#,
      16#08#,
      16#24#,
      16#18#,
      16#00#,
      16#10#,
      16#38#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#18#,
      16#00#,
      16#00#,
      16#24#,
      16#24#,
      16#24#,
      16#24#,
      16#2c#,
      16#14#,
      16#00#,
      16#00#,
      16#44#,
      16#44#,
      16#28#,
      16#28#,
      16#28#,
      16#10#,
      16#00#,
      16#00#,
      16#92#,
      16#aa#,
      16#aa#,
      16#aa#,
      16#aa#,
      16#44#,
      16#00#,
      16#00#,
      16#44#,
      16#28#,
      16#10#,
      16#10#,
      16#28#,
      16#44#,
      16#00#,
      16#28#,
      16#28#,
      16#28#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#00#,
      16#00#,
      16#3c#,
      16#04#,
      16#08#,
      16#10#,
      16#20#,
      16#3c#,
      16#00#,
      16#08#,
      16#10#,
      16#10#,
      16#20#,
      16#10#,
      16#10#,
      16#08#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#10#,
      16#00#,
      16#10#,
      16#08#,
      16#08#,
      16#04#,
      16#08#,
      16#08#,
      16#10#,
      16#00#,
      16#00#,
      16#00#,
      16#60#,
      16#92#,
      16#0c#,
      16#00#,
      16#00#,
      16#ff#,
      16#ff#,
      16#ff#,
      16#ff#,
      16#ff#,
      16#ff#,
      16#ff#,
      16#ff#);

   ----------
   -- Mask --
   ----------

   function Mask (Font : BMP_Font; Width_Offset : Natural) return UInt16 is
   begin
      case Font is
         when Font8x8 =>
            return 2**(8 - Width_Offset);
         when Font12x12 =>
            return 2**(16 - Width_Offset);
         when Font16x24 =>
            return 2**Width_Offset;
      end case;
   end Mask;

   ----------
   -- Data --
   ----------

   function Data
     (Font          : BMP_Font;
      C             : Character;
      Height_Offset : Natural) return UInt16
   is
      Char_Num   : constant Natural := Character'Pos (C);
      Char_Index : constant Natural := Char_Height (Font) *
                     (if Char_Num >= 32 and then Char_Num <= 128
                      then Char_Num - 32
                      else Character'Pos ('?') - 32);
   begin
      case Font is
         when Font8x8 =>
            return UInt16 (BMP_Font8x8 (Char_Index + Height_Offset));
         when Font12x12 =>
            return BMP_Font12x12 (Char_Index + Height_Offset);
         when Font16x24 =>
            return BMP_Font16x24 (Char_Index + Height_Offset);
      end case;
   end Data;

   -----------------
   -- Char_Height --
   -----------------

   function Char_Height (Font : BMP_Font) return Natural is
   begin
      case Font is
         when Font8x8 =>
            return 8;
         when Font12x12 =>
            return 12;
         when Font16x24 =>
            return 24;
      end case;
   end Char_Height;

   ----------------
   -- Char_Width --
   ----------------

   function Char_Width (Font : BMP_Font) return Natural is
   begin
      case Font is
         when Font8x8 =>
            return 8;
         when Font12x12 =>
            return 12;
         when Font16x24 =>
            return 16;
      end case;
   end Char_Width;

end BMP_Fonts;
